
(defun c:pklad ()

  (setvar "attreq" 0)
  (setvar "cmdecho" 0)
  
  ;(setq je (getvar "date"))
  ;(if (> je 2454530.0) (exit))                                      
  
  (setq cfglist ())                                                   ; = Variable fr gesamte cfg-Datei, jedoch ohne Attribute
  (setq cfglist0 ())                                                  ; = Variable fr eine Sektion (einen Punkttyp) der cfg-Datei, jedoch ohne Attribute
  (setq attmasklist ())                                               ; = Variable fr Attributmasken in gesamter cfg-Datei 
  (setq attmasklist0 ())                                              ; = Variable fr Attributmasken in einer Sektion (ein Punkttyp)
  (setq cfgfilepfad (getfiled "Konfigurationsdatei whlen ..." "s:/software/autocad/autolisp/eigene_lisps/004_punkte_laden/cfg/einles2.cfg" "cfg" 0))

  (setq cfgdat (open cfgfilepfad "r"))                                ; Konfigurationsdaten-File ffnen
  (while
    (setq configzeile (read-line cfgdat))                             ; Einlesen der Konfigurationsdatenzeilen ... erfolgt aufgrund des while-Befehls nur, wenn read-line nicht NIL ergibt
    (setq configzeile (strcat configzeile " "))                       ; die Zeile wird um ein Lehrzeichen verlngert, damit mit der nachfolgenden Routine auch der letzte Dateneintrag extrahiert wird
    (setq cfglist1 ())                                                ; cfglist1 = Variable fr eine Zeile der cfg-Datei
    (if                                                               ; wenn 1. Zeichen von configzeile kein ";" (Kommentarzeile) ist, dann wird die Datenzeile in Listenform gebracht ...
      (/= (substr configzeile 1 1) ";")
      (progn
        (setq i 0)
        (setq configeintrag "")
        (while
          (< i (strlen configzeile))
          (setq i (1+ i))
          (if                                                          ; wenn extrahiertes Zeichen kein Leerzeichen ist,
            (/=
              (substr configzeile i 1)
              " "
            )
            (progn                                                      ; dann wird Zeichen fr Zeichen "aufsummiert" ...
              (setq configeintrag
                (strcat
                  configeintrag 
                  (substr configzeile i 1)
                )
              )
              (setq angeschrieben "nein")
            )
            (progn                                                      ; sonst (Leerzeichen gefunden) wird das jeweilige Feld in die Liste geschrieben,
              (if                                                       
                (= angeschrieben "nein")                                ; vorrausgesetzt, es wurde nicht schon angeschrieben (wenn mehrere Lehrzeichen hintereinander)
                (progn
                  (setq cfglist1 (cons configeintrag cfglist1))           ; die Felder werden nach und nach in die Liste cfglist1 (= Liste von einer cfg-Datenzeile) geschrieben
                  (setq configeintrag "")
                  (setq angeschrieben "ja")
                )
              )
            )
          )             
        )
        (if
          (/= cfglist1 NIL)                                             ; cfglist1 wrde bei leeren Zeilen bzw. bei Zeilen die nur Leerzeichen enthalten NIL ergeben
          (if
            (= (car cfglist1) "SECTION_ENDE")
            (progn
              (setq cfglist (cons (reverse cfglist0) cfglist))
              (setq attmasklist (cons (reverse attmasklist0) attmasklist))
              (setq cfglist0 ())
              (setq attmasklist0 ())
            )
            (progn
              (if
                (= (car (reverse cfglist1)) "ATTRIBUT")                        ; wenn Eintrag in 1. cfg-Spalte = ATTRIBUT, dann ....
                (setq attmasklist0 (cons (reverse cfglist1) attmasklist0))     ; ... werden Daten in attmasklist0 geschrieben
                (setq cfglist0 (cons (reverse cfglist1) cfglist0))             ; ... sonst in cfglist0
              )
            )
          )                                             
        )
      )
    )
  )  
  (close cfgdat)
  (setq cfglist (reverse cfglist)
        attmasklist (reverse attmasklist)
        datlist ()
        attriblist ()
        datenfilepfad ""
        anzahl_geladene_bloecke 0
        anzahl_nicht_geladene_bloecke 0
        datenfilepfad (getfiled "Punktdatei whlen ..." "s:/software/autocad/autolisp/eigene_lisps/004_punkte_laden/dat/" "" 0)    ; ???? die Dateierweiterung (in diesem Fall txt) mu scheinbar eingegeben werden, damit er den vorgegebenen Pfad zum ffnen des Dialogfeldes heranzieht; sonst nimmt er immer den, den er sich vom letzten mal "gemerkt" hat
        pktdat (open datenfilepfad "r")                                  ; Punktdaten-File ffnen
  )
  (while
    (setq datenzeile (read-line pktdat))                                  ; Einlesen der Punktdatenzeilen ... erfolgt aufgrund des while-Befehls nur, wenn read-line nicht NIL
    (setq datenzeile (strcat datenzeile " ")                             ; die Zeile wird um ein Lehrzeichen verlngert, damit mit der nachfolgenden Routine auch der letzte Dateneintrag extrahiert wird
          datlist1 ()
          i 0
          dateneintrag ""
    )
    (if 
      (wcmatch datenzeile "*[~ ]*")                                     ; wenn Datenzeile "echte" Zeichen (gemeint sind alle Zeichen auer Leerzeichen) enthlt, ...
      (progn
        (while
          (< i (strlen datenzeile))
          (setq i (1+ i))
          (if                                                          ; wenn extrahiertes Zeichen kein Leerzeichen ist,
            (/= (substr datenzeile i 1)" ")                                               
            (setq dateneintrag (strcat dateneintrag (substr datenzeile i 1))  ; dann wird Zeichen fr Zeichen "aufsummiert" ...
                  angeschrieben "nein"
            )
            (if                                                       ; sonst (Leerzeichen gefunden) wird das jeweilige Feld in die Liste geschrieben,
              (= angeschrieben "nein")                                ; vorrausgesetzt, es wurde nicht schon angeschrieben
              (setq datlist1 (cons dateneintrag datlist1)             ; die Felder werden nach und nach in die Liste geschrieben
                    dateneintrag ""
                    angeschrieben "ja"
              )
            )
          )
        )
        (setq datlist1 (reverse datlist1)
              treffer 0
              j 0
        )
        (while
          (and
            (= treffer 0)
            (<= j (1- (length cfglist)))
          )
          (setq m (nth j cfglist)                                               ; m wird mit einem "Konfigurationsblock" des aktuellen Punktes belegt
                m1 (nth j attmasklist)                                          ; m1 wird mit der Attributmaskenliste des akutellen Punktes belegt
          )
          (if 
            (=
              (cadr (assoc "CODE" m))                                             ; wenn der Code in der cfg-Datei gleich dem Code
              (nth (1- (atoi (cadr (assoc "CODEFELD" m)))) datlist1)             ; in der Datenzeile ist, dann
            ) 
            (progn
              (setq treffer 1)
              (if (= (cadr (assoc "RECHTSWERT" m)) "AUS_DATEISPALTE")   (setq xkoord (nth (1- (atoi (caddr (assoc "RECHTSWERT" m)))) datlist1)))
              (if (= (cadr (assoc "RECHTSWERT" m)) "FIX")               (setq xkoord (caddr (assoc "RECHTSWERT" m))))
              (if (= (cadr (assoc "HOCHWERT" m)) "AUS_DATEISPALTE")     (setq ykoord (nth (1- (atoi (caddr (assoc "HOCHWERT" m)))) datlist1)))
              (if (= (cadr (assoc "HOCHWERT" m)) "FIX")                 (setq ykoord (caddr (assoc "HOCHWERT" m))))
              (if (= (cadr (assoc "HOEHE" m)) "AUS_DATEISPALTE")        (setq zkoord (nth (1- (atoi (caddr (assoc "HOEHE" m)))) datlist1)))
              (if (= (cadr (assoc "HOEHE" m)) "FIX")                    (setq zkoord (caddr (assoc "HOEHE" m))))
              (if (= (cadr (assoc "SKALIERUNG" m)) "AUS_DATEISPALTE")   (setq skal (nth (1- (atoi (caddr (assoc "SKALIERUNG" m)))) datlist1)))
              (if (= (cadr (assoc "SKALIERUNG" m)) "FIX")               (setq skal (caddr (assoc "SKALIERUNG" m))))               
              (if (= (cadr (assoc "ROTATION" m)) "AUS_DATEISPALTE")     (setq rotat (nth (1- (atoi (caddr (assoc "ROTATION" m)))) datlist1)))
              (if (= (cadr (assoc "ROTATION" m)) "FIX")                 (setq rotat (caddr (assoc "ROTATION" m))))
              (if (= (cadr (assoc "BLOCKPFAD" m)) "AUS_DATEISPALTE")    (setq blockpfad (nth (1- (atoi (caddr (assoc "BLOCKPFAD" m)))) datlist1)))
              (if (= (cadr (assoc "BLOCKPFAD" m)) "FIX")                (setq blockpfad (caddr (assoc "BLOCKPFAD" m))))
              (if (= (cadr (assoc "BLOCKNAME" m)) "AUS_DATEISPALTE")    (setq blockname (nth (1- (atoi (caddr (assoc "BLOCKNAME" m)))) datlist1)))
              (if (= (cadr (assoc "BLOCKNAME" m)) "FIX")                (setq blockname (caddr (assoc "BLOCKNAME" m))))
              
              (if                                                                 ; wenn der Block nicht geladen ist, wird der Blockpfad auf den gesamten Pfad+Name gesetzt.
                (= (tblsearch "BLOCK" blockname) NIL)                                            
                (command "_-insert" (strcat blockpfad blockname) "x" skal "y" skal "z" skal "d" rotat (strcat xkoord "," ykoord "," zkoord))       ; Block setzen (von dem Pfad laden, wie in cfg angegeben)                
                (command "_-insert" blockname "x" skal "y" skal "z" skal "d" rotat (strcat xkoord "," ykoord "," zkoord))                      ; Block setzen (die bereits in der Datei vorhandene Definition verwenden)
              )
              ;(redraw)
              ;(princ ".")
            ) 
            (setq j (1+ j))
          )
        )
        (if
          (= treffer 0)
          (progn
            (setq anzahl_nicht_geladene_bloecke (1+ anzahl_nicht_geladene_bloecke))
            (princ (strcat datenzeile ": NICHT geladen (Code nicht in *.cfg)\n"))
          )
          (progn
            (setq ename (entlast)                                                ; ename = letztes (soeben gesetztes) Hauptelement
                  edat  (entget ename)                                           ; zuerst Hauptelement modifizieren (Layer)
                  k     0
            )
            (if (= (cadr (assoc "EINLESLAYER" m)) "AUS_DATEISPALTE") (setq edat (subst (cons 8 (nth (1- (atoi (caddr (assoc "EINLESLAYER" m)))) datlist1)) (assoc 8 edat) edat)))
            (if (= (cadr (assoc "EINLESLAYER" m)) "FIX")             (setq edat (subst (cons 8 (caddr (assoc "EINLESLAYER" m))) (assoc 8 edat) edat)))
            (entmod edat)                                                                                                                  
            (while                                                                ; dann die Subelemente modifizieren (Attribute befllen)
              (/= (entnext ename) NIL)
              (setq ename (entnext ename)
                    edat (entget ename)
              )
              (if
                (= (cdr (assoc 0 edat)) "ATTRIB")
                (progn
                  (if (= (cadr (nth k m1)) "AUS_DATEISPALTE") (setq edat (subst (cons 1 (nth (1- (atoi (caddr (nth k m1)))) datlist1)) (assoc 1 edat) edat)))
                  (if (= (cadr (nth k m1)) "FIX")             (setq edat (subst (cons 1 (caddr (nth k m1))) (assoc 1 edat) edat)))
                  (if
                    (and (= (cadr  (nth k m1)) "SYSTEM") (= (caddr (nth k m1)) "ZEIT"))                        
                    (setq datum (rtos (getvar "CDATE") 2 8)
                          datumf (strcat (substr datum 1 4) "-" (substr datum 5 2) "-" (substr datum 7 2) " " (substr datum 10 2) ":" (substr datum 12 2) ":" (substr datum 14 2) "," (substr datum 16))
                          edat (subst (cons 1 datumf) (assoc 1 edat) edat)
                    )                    
                  )
                  (setq k (1+ k))
                  (entmod edat)
                )
              )
            )
            (setq anzahl_geladene_bloecke (1+ anzahl_geladene_bloecke))
            (princ (strcat datenzeile": geladen\n"))
          )
        )
      )
    )
  )
                                                      
  (close pktdat)
  (command "regen")
  (setvar "cmdecho" 1)
  (setvar "attreq" 1)
  (princ "--------------------------------------------------------------\n")
  (princ (strcat "\n" (itoa anzahl_geladene_bloecke) "x geladen, " (itoa anzahl_nicht_geladene_bloecke) "x nicht geladen.\n"))
  (princ)  
)


